Direct-product testing, and a new 2-query PCP Russell Impagliazzo (IAS & UCSD) Valentine Kabanets (SFU) Avi Wigderson (IAS) Direct Product: Definition For f : U R, the k -wise direct product fk : Uk Rk is fk (x1,…, xk) = ( f(x1), …, f(xk) ). [Impagliazzo’02, Trevisan’03]: TT ( fk ) DP Code is DP Encoding of TT ( f ) Rate and distance of DP Code are “bad”, but the code is still very useful in Complexity … DP Code: Two Basic Questions - Decoding: Given C ¼ fk, “find” f. (useful for Hardness Amplification) - Testing: Given C, test if C ¼ fk. (useful for PCP constructions) C is given as oracle Decoding Promise on C Search problem Small # queries vs. Testing no promise decision problem Minimal # queries Decoding: Hardness Amplification fk is harder to compute on average than f Motivation: Cryptography Pseudorandomness, Computational Complexity, PCPs DP Theorem/ XOR Lemma: [Yao82, Levin87, GL89, I94, GNW95, IW97, T03, IJK06, IJKW08] If C computes fk on ² of all (x1,…, xk) Uk Then C’ computes f on 1-δ of all x U ² = exp(-δk) Direct-Product Testing Given an oracle C : Uk Rk Test makes some queries to C, and (1) Accept if C = fk. (2) Reject if C is “far away” from any fk (2’) If Test accepts C with “high” probability ², then C must be “close” to some fk. - Want to minimize number of queries to C. - Want to minimize acceptance probability ² DP Testing History Given an oracle C : Uk Rk, is C¼ gk ? #queries acc. prob. Goldreich-Safra 00* 20 .99 Dinur-Reingold 06 2 .99 Dinur-Goldenberg 08 2 1/kα Dinur-Goldenberg 08 2 1/k New 3 exp(-kα) New* 2 1/kα * Derandomization / Consistency tests Test: Query C(S1), C(S2), … check consistency on common values. Thm: If Test accepts oracle C with prob ² then there is a function g: U R such that for ≈ ² of k-tuples S, C (S) ¼ gk (S) k S] [C(S) = g (S) in all but 1/k(1) elements in Unique Decoding List Decoding Proof: g(x) = Plurality { C (S)x | x 2 S} Consistency tests V-Test [GS00,FK00,DR06,DG08] Pick two random k-sets S1 = (B1,A), S2 = (A,B2) with m = k1/2 common elements A. Check if C(S1)A = C(S2)A Theorem [DG08]: If V-Test accepts with probability ² > 1/k(1) , B1 S1 B2 A S2 then there is g : U R s.t. C ¼ gk on at least ² fraction of k-sets. When ² < 1/k, the V-Test does not work. Z-Test Pick three random k-sets S1 =(B1, A1), S2=(A1,B2), S3=(B2, A2) with |A1| = |A2| = m = k1/2. Check if C(S1)A1= C(S2)A1 and C(S2)B2 = C(S3)B2 B1 S1 B2 A 2 S3 A1 S2 Theorem (main result): If Z-Test accepts with probability ² > exp(-k(1)), then there is g : U R s.t. C ¼ gk on at least ² fraction of k-sets. Proof Ideas Flowers, cores, petals Flower: determined by S=(A,B) Core: A B Core values: α=C(A,B)A Petals: ConsA,B = { (A,B’) | C(A,B’)A =α } In a flower, all petals agree on core values! [IJKW08]:Flower analysis B1 B2 A B3 B5 B4 V-Test ) Structure (similar to [FK, DG]) Suppose V-Test accepts with probability ². ConsA,B = { (A,B’) | C(A,B’)A = C(A,B)A } B (1) Largeness: Many (²/2) flowers (A,B) have many (²/2) petals ConsA,B (2) Harmony: In every large flower, almost all pairs of overlapping sets in Cons are almost perfectly consistent. B1 B2 A B3 B5 B4 V-Test: Harmony For random B1 = (E,D1) and B2 = (E,D2) (|E|=|A|) Pr [B1 2 Cons & B2 2 Cons & C(A, B1)E C(A, B2)E ] < ²4 << ² D1 B A E E A D2 Proof: Symmetry between A and E (few errors in AuE ) Chernoff: ² ¼ exp(-kα) Implication: Restricted to Cons, an approx V-Test on E accepts almost surely: Unique Decode! Harmony ) Local DP Main Lemma: Assume (A,B) is harmonious. Define g(x) = Plurality { C(A,B’)x | B’2 Cons & x 2 B’ } Then C(A,B’)B’ ¼ gk (B’), for almost all B’ 2 Cons D1 B x B’ A E D2 Intuition: g = g(A,B) is the unique (approximate) decoding of C on Cons(A,B) Idea: Symmetry arguments. Largness guarantees that random selections are near-uniform. Proof Sketch Main Lemma: Assume (A,B) is harmonious. Define g(x) = Plurality { C(A,B’)x | B’2 Cons & x 2 B’ } Then C(A,B’)B’ ¼ gk (B’), for almost all B’ 2 Cons D1 B A E D2 Proof: Assume otherwise. A random B1 in Cons has many “minority” elements x where C(B1)x g(x). A random E ½ B1 has many “minority” elements [Chernoff] A random B2=(E,D2) is likely s.t. C(B2)E ¼ g(E) [def of g] Then C(B1)E C(B2)E, Hence no harmony ! Local DP structure Field of flowers (Ai,Bi) For each, gi s.t C(S) ¼ gik (S) if S2 Cons(Ai,Bi) Global g? B1 A B2 B3 A A Bi B A A Counterexample [DG] For every x 2 U pick a random gx: U R For every k-subset S pick a random x(S) 2 S Define C(S) = gx(S)(S) C(S1)A=C(S2)A “iff” x(S1)=x(S2) V-test passes with high prob: ² = Pr[C(S1)A=C(S2)A] ~ m/k2 No global g if ² < 1/k2 B1 S1 B2 A S2 From local DP to global DP How to “glue” local solutions? ² > 1/kα “double excellence” (2 queries) [DG] ² > exp(-kα) Z-test (3 queries) Local to Global DP: small ² Lemma: (A1,B1) random (Cons large w.p. ²/2). Define g(x) = Plurality { C (A1,B’)x | B’2 Cons & x 2 B’ } Then C(S) ¼ gk (S), for ¼ ²/4 of all S B1 B2 A 2 A1 B1 (local) (global) B1 A1 B2 AB2 A2 2 A1 Local to Global DP: Z-test Proof: Cons = ConsA1,B1. Define g(x) = Plurality { C(A1,B’)x | B’2 Cons & x 2 B’ } Harmony implies C(A1,B’)B’ ¼ gk (B’), for almost all B’2Cons B1 A1 Can assume Flower (A1, B1 ) is large, (otherwise V-Test rejects) So (A1, B1) harmonious have g. S B2 A 2 Z-Test rejects ( Pick random S=(B2, A2). May assume B2 in Cons (otherwise V-Test rejects) If g(S) very different from C(S), then g(B2) C(S )B2 But g(B2) ¼ C(A1,B2)B2 Local to Global DP: large ² “double harmony” B1 A1 S B2 Three events all happen with probability > poly(m/k) (1) (A1, B1) is harmonious, g1 (2) (A2, B2) is harmonious, g2 A2 (3) S is consistent with both • Get that g1 (x) = g2 (x) for most x2 U. Derandomization Inclusion graphs are Samplers Most lemmas analyze sampling properties m-subsets A k-subsets elements of U S Cons x Subsets: Chernoff bounds – exponential error Subspaces: Chebychev bounds – polynomial error Derandomized DP Test Derandomized DP: fk (S), for linear subspaces S (similar to [IJKW08] ) . Theorem (Derandomized V-Test): If derandomized V-Test accepts C with probability ² > poly(1/k), then there is a function g : U R such that C (S) ¼ gk (S) on poly(²) of subspaces S. Corollary: Polynomial rate testable DP-code with [DG] parameters! Application: PCPs Constraint Satisfaction Problem A graph CSP over alphabet §: • Given a graph G=(V,E) on n nodes, and edge constraints Áe: §2 {0,1} ( e2 E ), • is there an assignment f: V § that satisfies all edge constraints. Example: 3-Colorability ( § = {1,2,3}, Áe (a,b) = 1 iff a b ) PCP Theorem [AS,ALMSS] For some constant 0<±<1 and constant-size alphabet §, it is NP-hard to distinguish between satisfiable graph CSPs over §, and ±-unsatisfiable ones (where every assignment violates at least ± fraction of edge constraints). 2-query PCP ( with completeness 1, soundness 1-± ) : PCP proof = assignment f: V §, Verifier: Accept if f satisfies a random edge Q1 Q2 Decreasing soundness by repetition sequential repetition : proof f: V § soundness : 1-± (1-±)kQ1 Q3 Q2k-1 X # queries: 2k Q2 Q4 parallel repetition : # queries : 2 X soundness: ? Q2k proof F: Vk §k Q1 Q2 PCP Amplification History f: V Σ, F : Vk Σk |V|=N , t= log |Σ| size #queries soundness Sequential repetition Verbitsky Raz Holenstein Feige-Verbitsky Rao Projection games Raz Feige-Kilian New N Nk Nk Nk Nk Nk Nk Nk Nk Moshkovitz-Raz N1+o(1) 2k 2 2 2 2 2 2 2 2 exp( - ± k ) very-slow(k) 0 exp( - ±32 k/ t) exp( - ±3 k/ t) t essential exp( - ±2 k ) ±2 essential 1/kα exp ( - ± k1/2) 2 1/loglog N Ideas: DP-Test of the PCP proof Given F : Vk § k, test if F = fk for some f: V § and test random constraints! If F close to fk, we get exponential decay (as sequential-repetition) in soundness ! Combine tests to minimize # of queries. Replace Z-test by V-test (local DP suffices) A New 2-Query PCP (similar to [FK]) For a regular CSP graph G = (V, E), proof is CE : Ek (§2)k the PCP Q1 Q2 Accept if (1) CE (Q1) and CE (Q2) agree on common vertices, and (2) all edge constraints are satisfied The 2-query PCP amplification Q1 Q2 Theorem: If CSP G=(V,E) is satisfiable, there is a proof CE that is accepted with probability 1. If CSP is ± – unsatisfiable, then no CE is accepted with probability > exp ( - ± k1/2). Corollary: A 2-query PCP over §k, of size nk, perfect completeness, and soundness exp(- k1/2). Analysis of our PCP construction PCP Analysis Q1 Q2 From CE : Ek (§2)k to the vertex proof C : Vk §k : C(v1,…, vk) = CE( e1,…, ek) for random incident edges Consistency of CE , Consistency of C Main Lemma for C yields local DP function g : V § Back to CE: g is also local DP for CE (symmetry) g (Q2) ¼ CE (Q2) (since Q2 2 ConsQ1) g(Q2) violates > ± edges (by soundness of G & Chernoff) Hence, CE (Q2) violates some edges, and Test rejects Summary Direct Product Testing: 3 queries & exponentially small acceptance probability Derandomized DP Testing: 2 queries & polynomially small acceptance probability ( derandomized V-Test of [DG08] ) PCP: 2-Prover parallel k-repetition for restricted games, with exponential in k1/2 decrease in soundness Open Questions Better dependence on k in our Parallel Repetition Theorem : exp ( - ± k) ? Derandomized 2-Query PCP : Obtaining / improving [Moshkovitz-Raz’08, Dinur-Harsha’09] via DP-testing ?